/* makelowe.c * Content-Type: TEXT/PLAIN; charset=cp866
 *
 * LowerCase filenames in ZIP file.    㪢   䠩  .ZIP.
 *
 * It is needed to minimize additi-    ணࠬ 㦭  樨  -
 * onal procedures of  installation   ⥫  楤    ⠫樨
 * programms from ZIP files created   ணࠬ   ZIP 娢, ᮧ  
 * under DOS. DOS PKZIP.EXE  writes   . ᪨  pkzip      娢
 * uppercased filenames to zipfile.    䠩 ய묨 㪢.
 *
 * Note!                              !
 * It is very stupid programm!         祭 㯠 ணࠬ!
 * Do  not use it, if ZIP file  may    ᯮ , ᫨ 娢 ᮧ  
 * be created by  non-DOS ZIP.  De-    . ⮤ Deflating    -
 * flating algorythm may contain NO   ঠ   Data_Length    ,
 * Data_Length data in header if it   ᫨  ᮧ   ᫥⥫쭮 -
 * was created on  non-seekable de-   .  ⠪   ᠫ ४⭮  
 * vice. I have NOT written code to    ࠧ ⠪ ⮢ .
 * analyse bit stream properly. :-(
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

/* --------------------------------------------- readen from file data: */
char		Name[32768L];			/* Buffer for filename	*/
unsigned short	Name_Length;			/* Length of filename	*/
unsigned short	Extra_Length;			/* Length of extra field*/
unsigned short	Comment_Length; 		/* Length of Comment	*/
unsigned long	Data_Length;			/* Length of file data	*/
unsigned long	Crc;				/* Crc of file data	*/
unsigned short	BitFlags;			/* general purpose flags*/
unsigned long	Sign;				/* Signature		*/
unsigned short	Version;			/* Version needed	*/
unsigned short	Method; 			/* Packing Method	*/

#define Read(A) fread(&A,sizeof(A),1,file)

void main(int argc, char **argv)
{
int dummy;
FILE *file;
unsigned int i, j;
unsigned long offkeep;

if (argc <= 1)
	{
	puts("Utility to lower filenames in zipfile[s]. (C) Sergej Qkowlew 2:5020/122");
	puts("Usage:");puts("makelowe file1.zip [file2.zip...]");
	puts("Errorlevels:");
	puts("0 - Success;      1 - this help;        2 - no file found;");
	puts("3 - I/O error;    4 - File contains data created on non-seekable device.");
	exit(1);
	}
else;

for (j = 1; j < argc; j++)
    {
    if (argv[j]) file = fopen(argv[j],"rb+"); else goto No_File;
    if (file)
	{
/* --------- Read file header and skip file data -------------------------- */
	do  { /* while (Sign == 0x04034b50 */
	    Sign = 0L;
	    Read(Sign);
	    if (Sign == 0x04034b50L)
		{
		Read(Version);
		Read(BitFlags);
		Read(Method);
		fseek(file,4L,SEEK_CUR);
		Read(Crc);
		Read(Data_Length);		/* read compressed size   */
		fseek(file,4L,SEEK_CUR);	/* skip uncompressed size */
		Read(Name_Length);
		Read(Extra_Length);
		if (Name_Length >= 32768L) goto Too_Long; else;
/* ------------ Read, lowercase and write back filename field ------------- */
		if (Name_Length)
		   {
		   offkeep = ftell(file);
		   fread(Name,1,Name_Length,file);
		   for (i = 0; i < Name_Length; i++)
			Name[i] = (char)(tolower((int)(Name[i])));
		   fseek(file,offkeep,SEEK_SET);
		   fwrite(Name,1,Name_Length,file);
		   fflush(file);
		   fseek(file,offkeep,SEEK_SET);
		   fread(Name,1,Name_Length,file);
		   }
		else;
/* ------------ Skip extra field ------------------------------------------ */
		if (Extra_Length) fseek(file,(long)Extra_Length,SEEK_CUR); else;
/* ------------ Skip filedata --------------------------------------------- */
		if (Crc != 0L)
		   if (Data_Length) fseek(file, Data_Length,SEEK_CUR); else;
		else if (Name[Name_Length - 1] != '/')
			{
			printf ("Deflating Method not analysed properly. Sorry!");
			exit(4);
			}
		     else; /* Directory has zero Crc and Data_Length too */
		} /* if Sign == 0x04034b50 */
	    else;
	    }
	while ((Sign == 0x04034b50L) && (!feof(file)) && (!ferror(file)));
/* ----------- Read/write directory of .ZIP archive ----------------------- */
	while ((Sign == 0x02014b50L) && (!feof(file)) && (!ferror(file)))
		{
		fseek(file,24L,SEEK_CUR);
		Read(Name_Length);
		Read(Extra_Length);
		Read(Comment_Length);
		fseek(file,12L,SEEK_CUR);
		if (Name_Length >= 32768L) goto Too_Long; else;
/* ------------ Read, lowercase and write back filename field ------------- */
		if (Name_Length)
		   {
		   offkeep = ftell(file);
		   fread(Name,1,Name_Length,file);
		   for (i = 0; i < Name_Length; i++)
			Name[i] = (char)(tolower((int)(Name[i])));
		   fseek(file,offkeep,SEEK_SET);
		   fwrite(Name,1,Name_Length,file);
		   fflush(file);
		   fseek(file,offkeep,SEEK_SET);
		   fread(Name,1,Name_Length,file);
		   }
		else;
/* ------------ Skip extra field ------------------------------------------ */
		if (Extra_Length) fseek(file,(long)Extra_Length,SEEK_CUR); else;
		if (Comment_Length) fseek(file,(long)Comment_Length,SEEK_CUR); else;
		Read(Sign);
		} /* while ((Sign == 0x02014b50L) && (!feof(file)) && (!ferror(file))) */
	if (ferror(file)) goto Err_File; else;
	if (fclose(file)) goto Err_File; else;
	} /* if (file) */
    else
	{
No_File:
	fputs("Not found file: ", stdout);
	puts(argv[j]);
	exit(2);
	}
    } /* for (j < argc) */
exit(0);

Too_Long:
fputs ("Too Long filename (>32768) encountered in file: ", stdout);
puts(argv[j]);
exit(3);

Err_File:
fputs ("Read/Write error on file: ", stdout);
puts(argv[j]);
exit(3);
} /* main() */
